import { ParamParseKey } from 'react-router/lib/router';
import { DecodedValueMap, ParamsFunctionType, ParamTypes, TypedPathMatch } from './types';
export declare function createRoute<ParamKey extends ParamParseKey<Path>, Path extends string, ParamsConfig extends ParamTypes<ParamKey>>(pattern: Path, paramTypes?: ParamsConfig): {
    link: ParamsFunctionType<Path, ParamsConfig, ParamKey>;
    route: string;
    pattern: Path;
    useParams: () => DecodedValueMap<ParamsConfig, ParamKey>;
    useMatch: () => TypedPathMatch<ParamsConfig, ParamKey> | null;
    matchPath: (path: string) => TypedPathMatch<ParamsConfig, ParamKey> | null;
};
